<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CustomTextOptionsDataList StructType
 * @subpackage Structs
 */
class CustomTextOptionsDataList extends AbstractStructBase
{
    /**
     * The customTextOptionValue
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * @var \StructType\CustomTextOptionsData[]
     */
    public $customTextOptionValue;
    /**
     * Constructor method for CustomTextOptionsDataList
     * @uses CustomTextOptionsDataList::setCustomTextOptionValue()
     * @param \StructType\CustomTextOptionsData[] $customTextOptionValue
     */
    public function __construct(array $customTextOptionValue = array())
    {
        $this
            ->setCustomTextOptionValue($customTextOptionValue);
    }
    /**
     * Get customTextOptionValue value
     * @return \StructType\CustomTextOptionsData[]|null
     */
    public function getCustomTextOptionValue()
    {
        return $this->customTextOptionValue;
    }
    /**
     * Set customTextOptionValue value
     * @throws \InvalidArgumentException
     * @param \StructType\CustomTextOptionsData[] $customTextOptionValue
     * @return \StructType\CustomTextOptionsDataList
     */
    public function setCustomTextOptionValue(array $customTextOptionValue = array())
    {
        foreach ($customTextOptionValue as $customTextOptionsDataListCustomTextOptionValueItem) {
            // validation for constraint: itemType
            if (!$customTextOptionsDataListCustomTextOptionValueItem instanceof \StructType\CustomTextOptionsData) {
                throw new \InvalidArgumentException(sprintf('The customTextOptionValue property can only contain items of \StructType\CustomTextOptionsData, "%s" given', is_object($customTextOptionsDataListCustomTextOptionValueItem) ? get_class($customTextOptionsDataListCustomTextOptionValueItem) : gettype($customTextOptionsDataListCustomTextOptionValueItem)), __LINE__);
            }
        }
        $this->customTextOptionValue = $customTextOptionValue;
        return $this;
    }
    /**
     * Add item to customTextOptionValue value
     * @throws \InvalidArgumentException
     * @param \StructType\CustomTextOptionsData $item
     * @return \StructType\CustomTextOptionsDataList
     */
    public function addToCustomTextOptionValue(\StructType\CustomTextOptionsData $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\CustomTextOptionsData) {
            throw new \InvalidArgumentException(sprintf('The customTextOptionValue property can only contain items of \StructType\CustomTextOptionsData, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->customTextOptionValue[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\CustomTextOptionsDataList
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
